package MessageAppl;

import java.io.BufferedReader;
import java.io.InputStreamReader;

import org.omg.CORBA.Contained;
import org.omg.CORBA.InterfaceDef;
import org.omg.CORBA.InterfaceDefHelper;
import org.omg.CORBA.StringHolder;

/**
 * 
 * @author Fosco
 * 
 * Implementazione client
 */
public class client
{

  public static void main(String[] args)
  {
    BufferedReader input = new BufferedReader(new InputStreamReader(System.in));

    try
    {
      // Inizializzazione ORB
      org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init((String[]) null, null);

      // Legge lo IOR da standard input
      org.omg.CORBA.Object tmp_ref;
      org.omg.CORBA.Object obj_mio;
      // Get the naming context
      tmp_ref = orb.resolve_initial_references("NameService");
      org.omg.CosNaming.NamingContextExt default_context = org.omg.CosNaming.NamingContextExtHelper
          .narrow(tmp_ref);

      // Stampo l'Instance Object Reference (IOR) su standard output
      System.out.println("Ecco lo IOR del contesto di default:\n"
          + orb.object_to_string(default_context));

      tmp_ref = default_context.resolve_str("0000174032");
      org.omg.CosNaming.NamingContext my_context = org.omg.CosNaming.NamingContextHelper
          .narrow(tmp_ref);

      // Stampo l'Instance Object Reference (IOR) su standard output
      System.out.println("Ecco lo IOR del mio contesto:\n"
          + orb.object_to_string(my_context));

      org.omg.CosNaming.NameComponent[] name = default_context
          .to_name("MessageApp_Message");
      System.out
          .println("Sono qui, nome dell'oggetto che sto per registrare, id: "
              + name[0].id + ", kind: " + name[0].kind);
      obj_mio = my_context.resolve(name);
      org.omg.CORBA.Object tmp_interfaccia = obj_mio._get_interface_def();

      // System.out.println("Ecco il riferimento all'interfaccia:
      // "+tmp_interfaccia);
      InterfaceDef interfaccia = InterfaceDefHelper.narrow(tmp_interfaccia);
      System.out.println("Estraggo il nome dell'interfaccia: \n"
          + interfaccia.describe_interface().defined_in);
      
      org.omg.CORBA.Object tmp_ir = orb.string_to_object(args[0]);
      org.omg.CORBA.Repository irep = org.omg.CORBA.RepositoryHelper.narrow(tmp_ir);
      Contained cont = irep.lookup_id("IDL:MessageAppl/Message:1.0");
      System.out.println("Ecco il nome assoluto del contenuto: \n"+cont.absolute_name());
      
      
      
      
      

      // Stampo l'Instance Object Reference (IOR) su standard output
      System.out.println("Ecco lo IOR dell'oggetto cercato:\n"
          + orb.object_to_string(obj_mio));

      // Creazione stub
      Message message_proxy = MessageHelper.narrow(obj_mio);

      // Input/output: messaggio da dividere, poi coda
      StringHolder inString = new StringHolder();
      // Input: separatore
      String sep;
      // Output: testa del messaggio
      StringHolder testa = new StringHolder();

      // Logica di servizio
      System.out
          .print("Dammi la stringa da dividere (nella forma \"testa<SEP>coda\":");
      // aggiungere eventuali controlli sull'input
      inString.value = input.readLine();
      System.out.print("Dammi <SEP>, ad esempio \"|\":");
      sep = input.readLine();
      message_proxy.split(inString, testa, sep);
      System.out.println("Ecco la testa: " + testa.value + ", e la coda: "
          + inString.value);
    } catch (Exception e)
    {
      System.out.println("Eccezione, la seguente: " + e);
      e.printStackTrace();
    }

  }
}