
package MessageAppl;
import org.omg.PortableServer.*;

/**
 * 
 * @author Fosco
 * 
 * Implementazione server
 */
public class server
{

public static void main(String[] args)
  {
    try
    {      
      //Inizializzazione ORB
      org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init((String[])null, null);
      
      //Risoluzione naming context di default
      org.omg.CORBA.Object tmp_ref = orb.resolve_initial_references("NameService");
      org.omg.CosNaming.NamingContextExt default_context = org.omg.CosNaming.NamingContextExtHelper.narrow(tmp_ref);

      // Stampo l'Instance Object Reference (IOR) su standard output
      System.out.println("Ecco lo IOR del contesto di default:\n"+orb.object_to_string(default_context));       

      org.omg.CosNaming.NamingContext my_context;
      org.omg.CORBA.Object tmp_obj;

      // Controlliamo che il nome, 0000174032, non sia gi utilizzato (bound)
      try {tmp_obj = default_context.resolve_str("0000174032");}
      catch (org.omg.CosNaming.NamingContextPackage.NotFound nf)
      {// Name is not yet bound, create a new context
       org.omg.CosNaming.NameComponent [] tmp_name = default_context.to_name("0000174032");
       tmp_obj = default_context.bind_new_context(tmp_name);
      }
      // Narrow the reference to a naming context.
      my_context = org.omg.CosNaming.NamingContextHelper.narrow(tmp_obj);

      // Stampo l'Instance Object Reference (IOR) su standard output
      System.out.println("Ecco lo IOR del mio contesto:\n"+orb.object_to_string(my_context));            
      
      if (my_context==null) {
               System.out.println("Error: Cannot narrow naming context called `"
                  + "0000174032" +  "'." );
               throw new org.omg.CORBA.BAD_PARAM();
      }
      
      // Ottengo un riferimento al POA 
      POA rootPOA = POAHelper.narrow(orb.resolve_initial_references("RootPOA"));          

      // Creazione oggetto servant
      MessageImpl servant = new MessageImpl();

      // Registro l'oggetto presso il POA
      org.omg.CORBA.Object obj = rootPOA.servant_to_reference(servant);

      // Attivazione POA -> altrimenti inizialmente il POA e' in stato Holding
      // cioe' richieste accodate, ma non trasmesse all'oggetto
      rootPOA.the_POAManager().activate();

      org.omg.CosNaming.NameComponent [] tmp_name = default_context.to_name("MessageApp_Message");      
      System.out.println("Sono qui, nome dell'oggetto che sto per registrare, id: "+tmp_name[0].id+", kind: "+tmp_name[0].kind);      
      my_context.rebind(tmp_name, obj);
            
      // Attivazione dei servizi
      orb.run();
    } catch (Exception e)
    {
      System.out.println("Ho ricevuto questa eccezione: "+e);
      e.printStackTrace();
    }
  }}