package Client;

import java.io.BufferedReader;
import java.io.InputStreamReader;

import org.omg.CORBA.Any;
import org.omg.CORBA.IRObject;
import org.omg.CORBA.Request;

/**
 * 
 * @author Fosco
 * 
 * Implementazione client
 */
public class client
{

  public static void main(String[] args)
  {
    BufferedReader input = new BufferedReader(new InputStreamReader(System.in));

    try
    {
      // Inizializzazione ORB
      org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init((String[]) null, null);

      // Legge lo IOR da standard input
      org.omg.CORBA.Object tmp_ref;
      org.omg.CORBA.Object obj_mio;
      // Get the naming context
      tmp_ref = orb.resolve_initial_references("NameService");
      org.omg.CosNaming.NamingContextExt default_context = org.omg.CosNaming.NamingContextExtHelper
          .narrow(tmp_ref);

      // Stampo l'Instance Object Reference (IOR) su standard output
      System.out.println("Ecco lo IOR del contesto di default:\n"
          + orb.object_to_string(default_context));

      tmp_ref = default_context.resolve_str("0000174032");
      org.omg.CosNaming.NamingContext my_context = org.omg.CosNaming.NamingContextHelper
          .narrow(tmp_ref);

      // Stampo l'Instance Object Reference (IOR) su standard output
      System.out.println("Ecco lo IOR del mio contesto:\n"
          + orb.object_to_string(my_context));

      org.omg.CosNaming.NameComponent [] name = default_context
          .to_name("MessageApp_Message");
      System.out
          .println("Sono qui, nome dell'oggetto che sto per registrare, id: "
              + name[0].id + ", kind: " + name[0].kind);
      obj_mio = my_context.resolve(name);

      // Stampo l'Instance Object Reference (IOR) su standard output
      System.out.println("Ecco lo IOR dell'oggetto cercato:\n"
          + orb.object_to_string(obj_mio));

      // Input/output: messaggio da dividere, poi coda
      String inString;
      // Input: separatore
      String sep;
      // Output: testa del messaggio
      String testa;

      // Logica di servizio
      System.out
          .print("Dammi la stringa da dividere (nella forma \"testa<SEP>coda\":");
      // aggiungere eventuali controlli sull'input
      inString = input.readLine();
      System.out.print("Dammi <SEP>, ad esempio \"|\":");
      sep = input.readLine();

      /*************** Codice cambiato (a parte eliminazione 
       * creazione stub)   DA QUI
       */


      // Ricerco i parametri della richiesta utilizzando l'interface repository
      obj_mio._get_interface_def();
      
      // Costruzione della request
      Request request = obj_mio._request("split");
      Any arg1Msg = request.add_inout_arg();
      Any arg2Inizio = request.add_out_arg();
      Any arg3Sep = request.add_in_arg();
      arg1Msg.insert_string(inString);
      // NOTA: bisogna SEMPRE inizializzare gli argomenti!!
      arg2Inizio.insert_string(""); //inizializzazione con stringa vuota
      arg3Sep.insert_string(sep);

      // Invocazione sincrona e bloccante del metodo remoto
      request.invoke();
      // Alternative possibili:
      // One-way -> per una invocazione senza risposta
      // (fire-and-forget)
      // request.send_oneway();
      // Asincrona -> invocazione asincrona, 
      // non bloccante in attesa di risposta
      //request.send_deferred();
      
      /*
       * Ciclo attivo di attesa, a polling, per la
       * chiamata asincrona (send_deferred)
       */
      /*while( request.poll_response()!=true ){
        System.out.println("Attesa attiva");
        try{Thread.sleep(5);}
        catch (Exception e) {
          e.printStackTrace();
        }
      }*/

      // Estrazione risposte
      inString = arg1Msg.extract_string(); // coda
      testa = arg2Inizio.extract_string(); //testa            
      
      /********************* Codice cambiato A QUI *************/

      System.out
          .println("Ecco la testa: " + testa + ", e la coda: " + inString);
    } catch (Exception e)
    {
      System.out.println("Eccezione, la seguente: " + e);
      e.printStackTrace();
    }

  }
}